//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#include "UN.h"

Define_Module(UN);

void UN::initialize()
{
    this->noOfEmpires = 0;
    noOfEmpiresVec.record(this->noOfEmpires);
    this->changesOfGovernment = 0;
    WATCH(noOfEmpires);
    WATCH(changesOfGovernment);
    WATCH_MAP(empires);
}

void UN::finish()
{
    noOfEmpiresVec.record(this->noOfEmpires);
    for( std::map<int,int>::iterator ii=empires.begin(); ii!=empires.end(); ++ii)
    {
       EV << (*ii).first << ": " << (*ii).second << endl;
    }
}

void UN::handleMessage(cMessage *msg)
{
    UNmsg *un = check_and_cast<UNmsg *>(msg);
    changesOfGovernment++;
    if (strcmp(un->getName(),"New Empire Emerges") == 0)
    {
        noOfEmpires++;
        noOfEmpiresVec.record(this->noOfEmpires);
        empires[un->getNewGovernment()] = 1;
    } else
    {
        if(!(empires.find(un->getOldGovernment()) == empires.end()))
        {
            empires[un->getOldGovernment()]--;
            if (empires[un->getOldGovernment()] == 0)
            {
                empires.erase(un->getOldGovernment());
                noOfEmpires--;
                noOfEmpiresVec.record(this->noOfEmpires);
            }
        }
        empires[un->getNewGovernment()]++;
    }
    delete msg;
}
